unit hiMemoryControl;

interface

uses Kol,Share,Debug,MemFuncs;

type
  THIMemoryControl = class(TDebug)
   private
    Adr:Pointer;
   public
    _prop_Count:integer;
    _prop_RecSize:integer;

    _data_RecSize:THI_Event;
    _data_Count:THI_Event;
    _event_onAllocateMem:THI_Event;
    _event_onDeallocateMem:THI_Event;

    procedure _work_doDeallocateMem(var _Data:TData; Index:word);
    procedure _work_doAllocateMem(var _Data:TData; Index:word);
    procedure _work_doReallocateMem(var _Data:TData; Index:word);
    procedure _var_MemSize(var _Data:TData; Index:word);
  end;

implementation


procedure THIMemoryControl._work_doDeallocateMem;
begin
  DeallocateMem(Adr);
  _hi_onEvent(_event_onDeallocateMem);
end;

procedure THIMemoryControl._work_doAllocateMem;
begin
  Adr:=AllocateMem(ReadInteger(_Data,_data_Count,_prop_Count),ReadInteger(_Data,_data_RecSize,_prop_RecSize));
  _hi_onEvent(_event_onAllocateMem);
end;

procedure THIMemoryControl._work_doReallocateMem;
begin
  ReallocateMem(Adr,ReadInteger(_Data,_data_Count,_prop_Count),ReadInteger(_Data,_data_RecSize,_prop_RecSize));
end;

procedure THIMemoryControl._var_MemSize;
begin
  _Data.data_type:=data_int;
  _Data.idata:=MemSize(Adr);
end;

end.
